--- kernel-source-2.4.21/arch/i386/kernel/io_apic.c.io-apic-resend-irq	2003-06-13 18:51:29 +0400
+++ kernel-source-2.4.21/arch/i386/kernel/io_apic.c	2003-07-28 18:06:27 +0400
@@ -188,6 +188,24 @@
 			clear_IO_APIC_pin(apic, pin);
 }
 
+#ifndef CONFIG_SMP
+
+void send_IPI_self(int vector)
+{
+	unsigned int cfg;
+
+	/*
+	 * Wait for idle.
+	 */
+	apic_wait_icr_idle();
+	cfg = APIC_DM_FIXED | APIC_DEST_SELF | vector | APIC_DEST_LOGICAL;
+	/*
+	 * Send the IPI. The write to APIC_ICR fires this off.
+	 */
+	apic_write_around(APIC_ICR, cfg);
+}
+#endif
+
 /*
  * support for broken MP BIOSs, enables hand-redirection of PIRQ0-7 to
  * specific CPU-side IRQs.
--- kernel-source-2.4.21/include/asm-i386/hw_irq.h.io-apic-resend-irq	2001-11-22 22:46:18 +0300
+++ kernel-source-2.4.21/include/asm-i386/hw_irq.h	2003-07-28 18:06:27 +0400
@@ -213,7 +213,7 @@
 	atomic_inc((atomic_t *)&prof_buffer[eip]);
 }
 
-#ifdef CONFIG_SMP /*more of this file should probably be ifdefed SMP */
+#if defined(CONFIG_X86_IO_APIC)
 static inline void hw_resend_irq(struct hw_interrupt_type *h, unsigned int i) {
 	if (IO_APIC_IRQ(i))
 		send_IPI_self(IO_APIC_VECTOR(i));
